<?php

/*
Plugin Name: FriendlyCode
Plugin URI: http://www.alistairphillips.com/2005/06/03/friendlycode/
Description: Adds syntax highlighting to your code for pretty display into Wordpress
Version: 0.1
Author: Alistair Phillips
Author URI: http://www.alistairphillips.com/
*/

class FriendlyCode {
}

if (function_exists('add_filter')) {
    function __friendlyCode($content) {
        /* $content now has the actual posts content in it so we are going to need to retrieve
        the code that is inside <friendlycode></friendlycode>        
        */               
        return preg_replace_callback("/<friendlycode([^>]*)>(.*?)<\/friendlycode>/is",
                                     '__syntax_hilight_callback',
                                     $content);        
    }  
    
    function __syntax_hilight_callback($match) {                       
        $attr = $match[1];
        $code = $match[2];
        
        /* It seems that WordPress is changing <?php to < ?php and some other bits around.  So fix it!*/
        $code = str_replace("< ?php", "<?php", $code);
        $code = str_replace("<br />", "", $code);        
        $code = preg_replace("/\\s*<p>/s", "\r\n\r\n", $code);
        $code = preg_replace("/<\/p>/s", "", $code);
        $code = str_replace("&#8220;", '"', $code);
        $code = str_replace("&#8221;", '"', $code);
        $code = str_replace("&#8216;", "'", $code);
        $code = str_replace("&#8217;", "'", $code);
        $code = str_replace("&#8211;", "--", $code);
        
        $re_lang = '/\s+lang\s*=\s*["\']?([^"\']+)["\']?/xi';
        $num = preg_match($re_lang, $attr, $lang);
        $lang = $lang[1];
        
        if ($num) {
            // We need to be using this stylesheet                        
            echo '<link rel="stylesheet" href="'.get_settings('siteurl').'/wp-content/plugins/friendlycode/hilight.css"/>';
            
            // We have a language attribute so need to perform the highlight
            ini_set("include_path", getcwd()."/wp-content/plugins/friendlycode");
            require_once 'friendlycode/Text/Highlighter.php';
            require_once 'friendlycode/Text/Highlighter/Renderer/Html.php';
            
            // Set the options
            $options = array(
                //'numbers' => HL_NUMBERS_TABLE,
                'tabsize' => 4,                        
            );                
            
            // Actually perform the highlight
            $renderer =& new Text_Highlighter_Renderer_HTML($options);
            $highlighter =& Text_Highlighter::factory($lang);            
            $highlighter->setRenderer($renderer);
            $code = $highlighter->highlight($code);
        }
        $code = str_replace("<pre>", "", $code);
        $code = str_replace("</pre>", "", $code);
        $code = nl2br($code);        
        return $code;
                        
    }
}    
    add_filter('the_content', '__friendlyCode');
?>